﻿//////////////////////////////////////////////////////////////////////////////
// Eigen value calculator written by Vladeta Stojanovic.
// This calculator can compute the eigen vectors and values of a given
// 3x3 symmetric matrix.
//
// Version: 080612_01
//////////////////////////////////////////////////////////////////////////////

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace eigenSolver
{
    public partial class Form1 : Form
    {
        public static double[,] matValues = new double[3,3];
        public static double[,] OutMatValues = new double[3, 3];
        public static double[]  OutVecValues = new double[3];
        public Eigen eigenCalculate;

        public Form1()
        {
            InitializeComponent();
            eigenCalculate = new Eigen();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        //SOLVE!
        private void button1_Click(object sender, EventArgs e)
        {
            eigenCalculate.eigen_decomposition(matValues, OutMatValues, OutVecValues);

            if (!eigenCalculate.calcDone)
            {
                MessageBox.Show("Calculation Still Running!");
            }
            else if (eigenCalculate.calcDone)
            {
                //output new eigen matrix
                textBox1_0.Text = OutMatValues[0, 0].ToString();
                textBox1_1.Text = OutMatValues[0, 1].ToString();
                textBox1_2.Text = OutMatValues[0, 2].ToString();
                textBox2_0.Text = OutMatValues[1, 0].ToString();
                textBox2_1.Text = OutMatValues[1, 1].ToString();
                textBox2_2.Text = OutMatValues[1, 2].ToString();
                textBox3_0.Text = OutMatValues[2, 0].ToString();
                textBox3_1.Text = OutMatValues[2, 1].ToString();
                textBox3_2.Text = OutMatValues[2, 2].ToString();

                //output calculated eigen vectors
                textBoxV0.Text = OutVecValues[0].ToString();
                textBoxV1.Text = OutVecValues[1].ToString();
                textBoxV2.Text = OutVecValues[2].ToString();
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            
            if (!eigenCalculate.calcDone)
            {
                MessageBox.Show("Calculation not complete! Solve matrix first.");
            }
            else if (eigenCalculate.calcDone)
            {
                MessageBox.Show("Results saved as Results.txt");
                eigenCalculate.OutResults(OutMatValues, OutVecValues);
            }
        }

        /////////////////////////////////////////////////////////////////
        // Input Boxes
        /////////////////////////////////////////////////////////////////
        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            if (eigenCalculate.IsNumeric(textBox1.Text))
            {
                matValues[0, 0] = double.Parse(textBox1.Text);
            }
            else
            {
                MessageBox.Show("Invalid Input!");
                textBox1.Text = "0";
            }
        }

        private void textBox2_TextChanged(object sender, EventArgs e)
        {
            if (eigenCalculate.IsNumeric(textBox2.Text))
            {
                matValues[0, 1] = double.Parse(textBox2.Text);
            }
            else
            {
                MessageBox.Show("Invalid Input!");
                textBox2.Text = "0";
            }
        }

        private void textBox3_TextChanged(object sender, EventArgs e)
        {
            if (eigenCalculate.IsNumeric(textBox3.Text))
            {
                matValues[0, 2] = double.Parse(textBox3.Text);
            }
            else
            {
                MessageBox.Show("Invalid Input!");
                textBox3.Text = "0";
            }
        }

        private void textBox4_TextChanged(object sender, EventArgs e)
        {
            if (eigenCalculate.IsNumeric(textBox4.Text))
            {
                matValues[1, 0] = double.Parse(textBox4.Text);
            }
            else
            {
                MessageBox.Show("Invalid Input!");
                textBox4.Text = "0";
            }
        }

        private void textBox5_TextChanged(object sender, EventArgs e)
        {
            if (eigenCalculate.IsNumeric(textBox5.Text))
            {
                matValues[1, 1] = double.Parse(textBox5.Text);
            }
            else
            {
                MessageBox.Show("Invalid Input!");
                textBox5.Text = "0";
            }
        }

        private void textBox6_TextChanged(object sender, EventArgs e)
        {
            if (eigenCalculate.IsNumeric(textBox6.Text))
            {
                matValues[1, 2] = double.Parse(textBox6.Text);
            }
            else
            {
                MessageBox.Show("Invalid Input!");
                textBox6.Text = "0";
            }
        }

        private void textBox7_TextChanged(object sender, EventArgs e)
        {
            if (eigenCalculate.IsNumeric(textBox7.Text))
            {
                matValues[2, 0] = double.Parse(textBox7.Text);
            }
            else
            {
                MessageBox.Show("Invalid Input!");
                textBox7.Text = "0";
            }
        }

        private void textBox8_TextChanged(object sender, EventArgs e)
        {
            if (eigenCalculate.IsNumeric(textBox8.Text))
            {
                matValues[2, 1] = double.Parse(textBox8.Text);
            }
            else
            {
                MessageBox.Show("Invalid Input!");
                textBox8.Text = "0";
            }
        }

        private void textBox9_TextChanged(object sender, EventArgs e)
        {
            if (eigenCalculate.IsNumeric(textBox9.Text))
            {
                matValues[2, 2] = double.Parse(textBox9.Text);
            }
            else
            {
                MessageBox.Show("Invalid Input!");
                textBox9.Text = "0";
            }
        }
    }
}
